/* =====================================================================

   LiMo - Liblary
      GdkPixbuf - pixel rotation.
                - GdkPixbufǲž롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Mar.22.2000  ߷ס

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  lm_pix_rot          -- Pixbufβž
  lm_pix_rot_new      -- PixbufžƿȤ֤

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "lm_pix_rot.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- ࡼ̵βž */
void rotation1(GdkPixbuf *, GdkPixbuf *, gfloat, gfloat,
	       gint, gint, gint, gint, gint, gint);

/* --- ࡼͭβž */
void rotation2(GdkPixbuf *, GdkPixbuf *, gfloat, gfloat,
	       gint, gint, gint, gint, gint, gint);

/* --- ԥ륹ࡼ󥰥ե륿 */
guint32 smooth_pixel(GdkPixbuf*, gint, gint,
		     gint, gint, gint, gint, gfloat, gfloat);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */


/* -----------------------------------------------------------------------
 --- Interface
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  lm_pix_rot          -- Pixbufβž

   src      - ž
   dest     - žǼ
   r        - ž(radian)
   mag      - Ψ (1.0 = )
   cx1,cy1  - žˤž濴ɸ
   cx2,cy2  - žˤž濴ɸ(Ǽեå)
   mode     - ࡼ󥰥⡼ɤλ(LM_PIXROT_NORMAL/SMOOTH)
-------------------------------------------------------------- */
void  lm_pix_rot(GdkPixbuf *src, GdkPixbuf *dest, gfloat r, gfloat mag,
		 gint cx1, gint cy1, gint cx2, gint cy2, gint mode)
{
  gint  w, h;

  w = gdk_pixbuf_get_width(src);
  h = gdk_pixbuf_get_height(src);

  if (mode == LM_PIXROT_SMOOTH) {
    rotation2(src, dest, r, mag, cx1, cy1, cx2, cy2, w, h);
  }
  else {
    rotation1(src, dest, r, mag, cx1, cy1, cx2, cy2, w, h);
  }
}


/* -------------------------------------------------------------
  lm_pix_rot_new      -- PixbufžƿȤ֤
                         žϲ濴

   src      - ž
   r        - ž(radian)
   mag      - Ψ (1.0 = )
   mode     - ࡼ󥰥⡼ɤλ(LM_PIXROT_NORMAL/SMOOTH)

   return : GdkPixbuf* žβ
-------------------------------------------------------------- */
GdkPixbuf  *lm_pix_rot_new(GdkPixbuf *src, gfloat r, gfloat mag, gint mode)
{
  GdkPixbuf *chr;
  gint    w, h;
  gint    rw, rh;
  gfloat  px, py;

  /* --- žΥФ */
  w = gdk_pixbuf_get_width(src);
  h = gdk_pixbuf_get_height(src);
  px = ((0 - (gfloat)(w/2)) * cos(r) + (0 - (gfloat)(h/2)) * sin(r))
    * (1.0 / mag);
  py = ((0 - (gfloat)(h/2)) * cos(r) - (0 - (gfloat)(w/2)) * sin(r))
    * (1.0 / mag);
  rw = abs((gint)px);
  rh = abs((gint)py);
  px = ((0 + (gfloat)(w/2)) * cos(r) + (0 - (gfloat)(h/2)) * sin(r))
    * (1.0 / mag);
  py = ((0 - (gfloat)(h/2)) * cos(r) - (0 + (gfloat)(w/2)) * sin(r))
    * (1.0 / mag);
  if (rw < abs((gint)px)) rw = abs((gint)px);
  if (rh < abs((gint)py)) rh = abs((gint)py);
  rw *= 2;
  rh *= 2;

  /* --- žβХåե */
  chr = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE, 8, rw, rh);

  /* --- ž */
  if (mode == LM_PIXROT_SMOOTH) {
    rotation2(src, chr, r, mag, w/2, h/2, rw/2, rh/2, w, h);
  }
  else {
    rotation1(src, chr, r, mag, w/2, h/2, rw/2, rh/2, w, h);
  }


  return(chr);
}




/* -----------------------------------------------------------------------
 --- Impriment
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  rotation1    -- ࡼ̵βž
-------------------------------------------------------------- */
void rotation1(GdkPixbuf *src, GdkPixbuf *dest, gfloat r, gfloat mag,
	       gint cx1, gint cy1, gint cx2, gint cy2, gint sw, gint sh)
{
  gint  w2, h2;
  gint  x1, y1, x2, y2;
  gint  dx1, dy1, dx2, dy2;
  gint  i, j;
  guint32  *ptr1, *ptr2;
  guchar   *ptr, *buf;
  gint      buf_size;

  sw *= 0x10000;
  sh *= 0x10000;
  w2 = gdk_pixbuf_get_width(dest);
  h2 = gdk_pixbuf_get_height(dest);
  buf = gdk_pixbuf_get_pixels(src);
  buf_size = gdk_pixbuf_get_rowstride(src);

  ptr2 = (guint32*)gdk_pixbuf_get_pixels(dest);
  x1 = (((0 - cx2) * cos(r) + (0 - cy2) * sin(r)) * (1 / mag) + cx1) * 0x10000;
  y1 = (((0 - cy2) * cos(r) - (0 - cx2) * sin(r)) * (1 / mag) + cy1) * 0x10000;
  dx1 = (((1 - cx2) * cos(r) + (0 - cy2) * sin(r)) * (1 / mag) + cx1) * 0x10000;
  dy1 = (((0 - cy2) * cos(r) - (1 - cx2) * sin(r)) * (1 / mag) + cy1) * 0x10000;
  dx2 = (((0 - cx2) * cos(r) + (1 - cy2) * sin(r)) * (1 / mag) + cx1) * 0x10000;
  dy2 = (((1 - cy2) * cos(r) - (0 - cx2) * sin(r)) * (1 / mag) + cy1) * 0x10000;
  dx1 -= x1;
  dy1 -= y1;
  dx2 -= x1;
  dy2 -= y1;
  for(j=0; j<h2; j++) {
    x2 = x1;
    y2 = y1;
    for(i=0; i<w2; i++) {
      if ((x2 >= 0) && (x2 < sw) && (y2 >= 0) && (y2 < sh)) {
	ptr = buf +  buf_size * (y2 >> 16) + ((x2 >> 16) * 4);
	ptr1 = (guint32 *)ptr;
	*ptr2 = *ptr1;
      }
      else {
	*ptr2 = 0;
      }
      ptr2++;
      x2 += dx1;
      y2 += dy1;
    }
    x1 += dx2;
    y1 += dy2;
  }
}


/* -------------------------------------------------------------
  rotation2    -- ࡼͭβž
-------------------------------------------------------------- */
void rotation2(GdkPixbuf *src, GdkPixbuf *dest, gfloat r, gfloat mag,
	       gint cx1, gint cy1, gint cx2, gint cy2, gint sw, gint sh)
{
  gint  w2, h2;
  gint  x1, y1, x2, y2;
  gint  dx1, dy1, dx2, dy2;
  gint  i, j;
  guint32  *ptr2;
  guchar   *buf;
  gint      buf_size;

  sw *= 0x10000;
  sh *= 0x10000;
  w2 = gdk_pixbuf_get_width(dest);
  h2 = gdk_pixbuf_get_height(dest);
  buf = gdk_pixbuf_get_pixels(src);
  buf_size = gdk_pixbuf_get_rowstride(src);

  ptr2 = (guint32*)gdk_pixbuf_get_pixels(dest);
  x1 = (((0 - cx2) * cos(r) + (0 - cy2) * sin(r)) * (1 / mag) + cx1) * 0x10000;
  y1 = (((0 - cy2) * cos(r) - (0 - cx2) * sin(r)) * (1 / mag) + cy1) * 0x10000;
  dx1 = (((1 - cx2) * cos(r) + (0 - cy2) * sin(r)) * (1 / mag) + cx1) * 0x10000;
  dy1 = (((0 - cy2) * cos(r) - (1 - cx2) * sin(r)) * (1 / mag) + cy1) * 0x10000;
  dx2 = (((0 - cx2) * cos(r) + (1 - cy2) * sin(r)) * (1 / mag) + cx1) * 0x10000;
  dy2 = (((1 - cy2) * cos(r) - (0 - cx2) * sin(r)) * (1 / mag) + cy1) * 0x10000;
  dx1 -= x1;
  dy1 -= y1;
  dx2 -= x1;
  dy2 -= y1;
  for(j=0; j<h2; j++) {
    x2 = x1;
    y2 = y1;
    for(i=0; i<w2; i++) {
      if ((x2 >= 0) && (x2 < sw) && (y2 >= 0) && (y2 < sh)) {
	*ptr2 = smooth_pixel(src, x2, y2, dx1, dy1, dx2, dy2, mag, mag);
      }
      else {
	*ptr2 = 0;
      }
      ptr2++;
      x2 += dx1;
      y2 += dy1;
    }
    x1 += dx2;
    y1 += dy2;
  }
}


/* -------------------------------------------------------------
  smooth_pixel -- ԥ륹ࡼ
-------------------------------------------------------------- */
guint32 smooth_pixel(GdkPixbuf *pic,
		     gint x, gint y,
		     gint dx1, gint dy1, gint dx2, gint dy2,
		     gfloat mx, gfloat my)
{
  guchar   *ptr1, *ptr2;
  guint     r, g, b, a;
  guint     r1, g1, b1, a1;
  guint     r2, g2, b2, a2;
  guint     ro, go, bo, ao;
  gint      blend, times;
  gint      x_loop, y_loop, tx, ty;

  ro = go = bo = ao = 0;
  blend = 0;

  x_loop = (gint)(1 / mx) + 1;
  y_loop = (gint)(1 / my) + 1;
  dx1 /= x_loop;
  dy1 /= y_loop;
  dx2 /= x_loop;
  dy2 /= y_loop;

  do {
    tx = x;
    ty = y;
    do {
      ptr1 = gdk_pixbuf_get_pixels(pic) +
	gdk_pixbuf_get_rowstride(pic) * (y >> 16) + ((x >> 16) * 4);
      ptr2 = gdk_pixbuf_get_pixels(pic) +
	gdk_pixbuf_get_rowstride(pic) * ((y >> 16) + 1) + ((x >> 16) * 4);

      if (((x >> 16) >= gdk_pixbuf_get_width(pic))
	  || ((y >> 16) >= gdk_pixbuf_get_height(pic))) {
	break;
      }

      r = g = b = a = 0;

      times = (x & 0xffff) >> 8;
      if (times > 0x40) {
	times -= 0x40;
	r1 = ptr1[0] * (0xc0 - times) + ptr1[4] * times;
	g1 = ptr1[1] * (0xc0 - times) + ptr1[5] * times;
	b1 = ptr1[2] * (0xc0 - times) + ptr1[6] * times;
	a1 = ptr1[3] * (0xc0 - times) + ptr1[7] * times;
	r2 = ptr2[0] * (0xc0 - times) + ptr2[4] * times;
	g2 = ptr2[1] * (0xc0 - times) + ptr2[5] * times;
	b2 = ptr2[2] * (0xc0 - times) + ptr2[6] * times;
	a2 = ptr2[3] * (0xc0 - times) + ptr2[7] * times;
      }
      else {
	r1 = ptr1[0] * 0xc0;
	g1 = ptr1[1] * 0xc0;
	b1 = ptr1[2] * 0xc0;
	a1 = ptr1[3] * 0xc0;
	r2 = ptr2[0] * 0xc0;
	g2 = ptr2[1] * 0xc0;
	b2 = ptr2[2] * 0xc0;
	a2 = ptr2[3] * 0xc0;
      }
      times = (y & 0xffff) >> 8;
      if (times > 0x40) {
	times -= 0x40;
	r = r1 * (0xc0 - times) + r2 * times;
	g = g1 * (0xc0 - times) + g2 * times;
	b = b1 * (0xc0 - times) + b2 * times;
	a = a1 * (0xc0 - times) + a2 * times;
      }
      else {
	r = r1 * 0xc0;
	g = g1 * 0xc0;
	b = b1 * 0xc0;
	a = a1 * 0xc0;
      }
      r /= 0xc0 * 0xc0;
      g /= 0xc0 * 0xc0;
      b /= 0xc0 * 0xc0;
      a /= 0xc0 * 0xc0;
      ro += r;
      go += g;
      bo += b;
      ao += a;
      blend++;
      x += dx1;
      y += dy1;
      x_loop--;
    } while(x_loop > 1);
    x = tx;
    y = ty;
    x += dx2;
    y += dy2;
    y_loop--;
  }while(y_loop > 1);

  r = ro / blend;
  g = go / blend;
  b = bo / blend;
  a = ao / blend;

  if (r > 0x100) r = 0xff;
  if (g > 0x100) g = 0xff;
  if (b > 0x100) b = 0xff;
  if (a > 0x100) a = 0xff;
  return(r | (g<<8) | (b<<16) | (a<<24));
}
