/* =====================================================================

   LiMo - Liblary
      Graphic Display System.  - ̴ȥ֥ɽ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Sep.12.1999  Programing start
  Sep.24.1999  First release
  Oct.24.1999  Revision 2.  (add OBJECT)
  Nov.28.1999  Revision 3.  (add Window Shape)
  Dec.17.1999  Revision 4.  (add Palette management)
  Dec.25.1999  Revision 5.  (mask probrem debug)
  Dec.29.1999  Revision 6.  (root screen for screensaver)
  Jan.15.2000  Revision 7.  (OBJECT add mask_offset sw)
  Jan.21.2000  Revision 8.  (High performance draw with Draw list)
  Feb.15.2000  Revision 9.  (RRScreenRectangle area check)
  Mar.23.2000  Revision 10. (root init debug)

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRScreenInit             -- ̽
  RRScreenFree             -- ̼곫
  RRScreenSwitch           -- ֥Хåեؤ
  RRScreenRedraw           -- Expose Event Ǥβ̥ɥ
  RRScreenBufNum           -- ֥Хåեν񤭹߲ǽڡ֤
  RRScreenBuffer           -- ߤν񤭹߲ǽ Pixmap ֤
  RRScreenGCColor          -- GC Υ顼ꤹ
  RRScreenGCGet            -- GC 
  RRScreenClear            -- 襹꡼ñɤĤ֤
  RRScreenCanvas           -- ɽåȤȤʤ drawable ֤
  RRScreenWindow           -- ɽåȤȤʤ window ֤
  RRScreenWinShape         -- ɽɥηޥ
  RRScreenSetPalette       -- ǥå顼
  RRScreenFontSetDirect    -- եľܻ
  RRScreenFontSetInit      -- եȤλ(ܸեȹ)
  RRScreenFontInit         -- եȤλʤ
  RRScreenFontLocate       -- եȤֻ
  RRScreenFontSize         -- ƥȤνĲ
  RRScreenFontPrint        -- ʸɽ
  RRScreenFontPrintDirect  -- Pixmapʸɽ
  RRScreenPutPixmap        -- 襹꡼Pixmapɽ
  RRScreenObjPut           -- Objectɽ
  RRScreenObjPutDirect     -- PixmapObjectɽ
  RRScreenPoint            -- ɽ
  RRScreenLine             -- 饤ɽ
  RRScreenRectangle        -- ͳѤɽ

  RRGetParts               -- åȾλ̾ҥåȤ֤


-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include "rr_screen.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- ϰϻѹ¤ */
typedef struct _RRRectangle RRRectangle;
struct _RRRectangle
{
  gint  x, y;
  gint  w, h;
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- ѤäꥢϿ */
static void  memo_add_bound(RRRectangle*);

/* --- Ťʤå */
static gboolean  check_over_area(RRRectangle*, RRRectangle*);

/* --- ˴ */
static void  free_drawmemo(GList*);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ֥륹꡼Хåե */
GdkPixmap *pixmap[2];

/* --- ꡼ڡ */
gint  page;

/* --- ꡼󥵥 */
gint  screen_w, screen_h;

/* --- եåƥ */
GdkGC     *win_gc[3];

/* --- ɽ꡼ widget */
GtkWidget  *canvas;
GtkWidget  *window;
GdkWindow  *root;

/* --- ꡼ؤΥ󥹥å */
gboolean   screen_copy_sw;

/* --- ѹ줿襨ꥢΥ */
GList      *drawmemo;
GMemChunk  *memo_chunk;

/* --- ɽեȤλ */
GdkFont  *sfont1 = NULL;

/* --- եȤɽ */
gint  font_x, font_y;

/* --- ɥηޥ */
GdkBitmap *win_mask = NULL;
GdkBitmap *win_mask_current = NULL;

/* --- ǥå顼 */
GdkColormap  *win_pal = NULL;
gint win_pal_n;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRScreenInit       -- ̴Ϣ

   return : void
   window   - ɽ륦ɥå
   screen   - window Drawable widget
   w        - 
   h        - ĥ
-------------------------------------------------------------- */
void RRScreenInit(GtkWidget *mainwin, GtkWidget *screen,
		  gint w, gint h, gboolean sw)
{
  /* size keep */
  screen_w = w;
  screen_h = h;
  window = mainwin;
  screen_copy_sw = sw;
  /* init */
  root = NULL;
  win_mask = NULL;
  win_pal = NULL;

  /* ɥ֥륨ꥢ */
  canvas = screen;

  /* ֥Хåե */
  pixmap[0] = gdk_pixmap_new(window->window, w, h, -1);
  pixmap[1] = gdk_pixmap_new(window->window, w, h, -1);
  win_gc[0] = gdk_gc_new(pixmap[0]);
  win_gc[1] = gdk_gc_new(pixmap[1]);
  win_gc[2] = gdk_gc_new(canvas->window);

  /* 񤭴ꥢ */
  drawmemo = NULL;
  memo_chunk = g_mem_chunk_new("draw memo", sizeof(RRRectangle),
			   sizeof(RRRectangle)*32, G_ALLOC_AND_FREE);

  /* ̾äƤ */
  page = 1;
  RRScreenClear(0, 0, 0);
  page = 0;
  RRScreenClear(0, 0, 0);

  /* ¾ */
  font_x = font_y = 0;
}


/* -------------------------------------------------------------
  RRScreenInitRoot   -- Root

   return : void
   window   - ɽ륦ɥå
   screen   - window Drawable widget
   w        - 
   h        - ĥ
   sw       - ؤ̥ԡ
-------------------------------------------------------------- */
void RRScreenInitRoot(GdkWindow *mainwin, gint w, gint h, gboolean sw)
{
  /* size keep */
  screen_w = w;
  screen_h = h;
  window = NULL;
  root = mainwin;
  win_mask = NULL;
  win_pal = NULL;
  screen_copy_sw = sw;

  /* ɥ֥륨ꥢ */
  canvas = NULL;

  /* ֥Хåե */
  pixmap[0] = gdk_pixmap_new(mainwin, w, h, -1);
  pixmap[1] = gdk_pixmap_new(mainwin, w, h, -1);
  win_gc[0] = gdk_gc_new(pixmap[0]);
  win_gc[1] = gdk_gc_new(pixmap[1]);
  win_gc[2] = gdk_gc_new(mainwin);

  /* 񤭴ꥢ */
  drawmemo = NULL;
  memo_chunk = g_mem_chunk_new("draw memo", sizeof(RRRectangle),
			   sizeof(RRRectangle)*32, G_ALLOC_AND_FREE);

  /* ̾äƤ */
  page = 1;
  RRScreenClear(0, 0, 0);
  page = 0;
  RRScreenClear(0, 0, 0);


  /* ¾ */
  font_x = font_y = 0;
}


/* -------------------------------------------------------------
  RRScreenFree       -- ̼곫

   return : void
   void
-------------------------------------------------------------- */
void       RRScreenFree(void)
{
  gdk_pixmap_unref(pixmap[0]);
  gdk_pixmap_unref(pixmap[1]);
  gdk_gc_destroy(win_gc[0]);
  gdk_gc_destroy(win_gc[1]);
  gdk_gc_destroy(win_gc[2]);
  g_mem_chunk_destroy(memo_chunk);
}


/* -------------------------------------------------------------
  RRScreenSwitch     -- ֥Хåեؤ

   return : ߤν񤭹߲ǽХåեֹ(0-1)
   void
-------------------------------------------------------------- */
gint       RRScreenSwitch(void)
{
  GList  *pt;
  RRRectangle  *area;
  gint    i, n;

  /* -- Ѥäʬ򥢥åץǡ */
  if (drawmemo != NULL) {
    gdk_gc_set_clip_mask(win_gc[2], win_mask);
    gdk_gc_set_clip_origin(win_gc[2], 0, 0);
    n = g_list_length(drawmemo);
    pt = drawmemo;
    for(i=0; i<n; i++) {
      area = (RRRectangle *)pt->data;
      gdk_draw_pixmap(canvas->window, win_gc[2], pixmap[page],
		      area->x, area->y,
		      area->x, area->y, area->w, area->h);
      pt = pt->next;
    }
  }

  /* -- Ԥޤ礦 */
  page ^= 1;

  /* -- β̤򥳥ԡ */
  if ((screen_copy_sw == TRUE) && (drawmemo != NULL)) {
    gdk_gc_set_clip_mask(win_gc[page], NULL);
    gdk_gc_set_clip_origin(win_gc[page], 0, 0);
    n = g_list_length(drawmemo);
    pt = drawmemo;
    for(i=0; i<n; i++) {
      area = (RRRectangle *)pt->data;
      gdk_draw_pixmap(pixmap[page], win_gc[page], pixmap[(page^1)],
		      area->x, area->y,
		      area->x, area->y, area->w, area->h);
      pt = pt->next;
    }
  }

  /* -- ˴ */
  free_drawmemo(drawmemo);
  drawmemo = NULL;

  /* -- Window Shape */
  if (win_mask != win_mask_current) {
    win_mask_current = win_mask;
    gtk_widget_shape_combine_mask(window, win_mask, 0, 0); 
  }

  return(page);
}


/* -------------------------------------------------------------
  RRScreenSwitchRoot     -- ֥Хåեؤ(Root)

   return : ߤν񤭹߲ǽХåեֹ(0-1)
   void
-------------------------------------------------------------- */
gint       RRScreenSwitchRoot(void)
{
  GList  *pt;
  RRRectangle  *area;
  gint    i, n;

  /* root window  */
  gdk_window_set_back_pixmap(root, pixmap[page], FALSE);
  gdk_window_clear(root);
  gdk_flush();

  /* -- Ԥޤ礦 */
  page ^= 1;

  /* -- β̤򥳥ԡ */
  if ((screen_copy_sw == TRUE) && (drawmemo != NULL)) {
    gdk_gc_set_clip_mask(win_gc[page], NULL);
    gdk_gc_set_clip_origin(win_gc[page], 0, 0);
    n = g_list_length(drawmemo);
    pt = drawmemo;
    for(i=0; i<n; i++) {
      area = (RRRectangle *)pt->data;
      gdk_draw_pixmap(pixmap[page], win_gc[page], pixmap[(page^1)],
		      area->x, area->y,
		      area->x, area->y, area->w, area->h);
      pt = pt->next;
    }
  }

  /* -- ˴ */
  free_drawmemo(drawmemo);
  drawmemo = NULL;

  return(page);
}


/* -------------------------------------------------------------
  RRScreenRedraw     -- Expose Event Ǥβ̥ɥ

   ꥿ expose event ˽ऺ
-------------------------------------------------------------- */
gboolean   RRScreenRedraw(GtkWidget *win, GdkEventExpose *expose,
			  gpointer user_data)
{
  if (window != 0) {
    /* --- ̾ */
    gdk_gc_set_clip_mask(win_gc[(page^1)], NULL);
    gdk_gc_set_clip_origin(win_gc[(page^1)], 0, 0);
    gdk_draw_pixmap(canvas->window, win_gc[(page^1)], pixmap[(page^1)], 
		    expose->area.x, expose->area.y,
		    expose->area.x, expose->area.y,
		    expose->area.width, expose->area.height);
  }
  else {
    /* --- root  */
    gdk_window_set_back_pixmap(root, pixmap[(page^1)], FALSE);
  }

  return(FALSE);
}


/* -------------------------------------------------------------
  RRScreenBufNum     -- ֥Хåեν񤭹߲ǽڡ

   return : ߤν񤭹߲ǽХåեֹ(0-1)
   void
-------------------------------------------------------------- */
gint       RRScreenBufNum(void)
{
  return(page);
}


/* -------------------------------------------------------------
  RRScreenBuffer     -- ߤν񤭹߲ǽ Pixmap ֤

   return : ߤν񤭹߲ǽPixmap pointera
   void
-------------------------------------------------------------- */
GdkPixmap *RRScreenBuffer(void)
{
  return(pixmap[page]);
}


/* -------------------------------------------------------------
  RRScreenCanvas     -- ɽåȤȤʤ drawable ֤

   return : ɽåȥå
   void
-------------------------------------------------------------- */
GtkWidget *RRScreenCanvas(void)
{
  return(canvas);
}


/* -------------------------------------------------------------
  RRScreenWindow     -- ɽåȤȤʤ륦ɥ֤

   return : ɽåȥå
   void
-------------------------------------------------------------- */
GtkWidget *RRScreenWindow(void)
{
  return(window);
}


/* -------------------------------------------------------------
  RRScreenIsRoot    -- ɽåȤϥ롼Ȥ

   return : ɽåȥå
   void
-------------------------------------------------------------- */
gboolean RRScreenIsRoot(void)
{
  gboolean r = FALSE;

  if (root != 0) {
    r = TRUE;
  }
  return(r);
}


/* -------------------------------------------------------------
  RRScreenRoot    -- ɽå(롼)

   return : ɽåroot
   void
-------------------------------------------------------------- */
GdkWindow *RRScreenRoot(void)
{
  return(root);
}


/* -------------------------------------------------------------
  RRScreenWinShape    -- ɽɥηޥ

   return : void
   shape  ɥΥޥBitmap
-------------------------------------------------------------- */
void RRScreenWinShape(GdkBitmap *shape)
{
  win_mask = shape;
}


/* -------------------------------------------------------------
  RRScreenSetPalette       -- ǥå顼

   return : void
   shape  ɥΥޥBitmap
-------------------------------------------------------------- */
void RRScreenSetPalette(GdkColormap *col, gint n)
{
  if (win_pal != col) {
    win_pal = col;
    win_pal_n = n;
    gdk_window_set_colormap(window->window, win_pal);
  }
}


/* -------------------------------------------------------------
  RRScreenGCColor    -- GC Υ顼ꤹ

   return : void
   r, g, b - λ
-------------------------------------------------------------- */
void       RRScreenGCColor(gint r, gint g, gint b)
{
  GdkColor  col;

  col.red = r;
  col.green = g;
  col.blue = b;
  gdk_color_alloc(gdk_colormap_get_system()  ,&col);
  gdk_gc_set_foreground(win_gc[page], &col);
}


/* -------------------------------------------------------------
  RRScreenGCGet      -- GC 

   return : void
   void
-------------------------------------------------------------- */
GdkGC     *RRScreenGCGet(void)
{
  return(win_gc[page]);
}


/* -------------------------------------------------------------
  RRScreenClear      -- 襹꡼ñɤĤ֤

   return : void
   r, g, b - λ
-------------------------------------------------------------- */
void       RRScreenClear(gint r, gint g, gint b)
{
  RRRectangle  area;

  RRScreenGCColor(r, g, b);
  gdk_gc_set_clip_mask(win_gc[page], NULL);
  gdk_gc_set_clip_origin(win_gc[page], 0, 0);
  gdk_draw_rectangle(pixmap[page], win_gc[page], TRUE,
		     0, 0, screen_w, screen_h);

  area.x = area.y = 0;
  area.w = screen_w;
  area.h = screen_h;
  memo_add_bound(&area);
}


/* -------------------------------------------------------------
  RRScreenFontSetDirect  -- եľܻ

   return : void
   font - եȥݥ
-------------------------------------------------------------- */
void       RRScreenFontSetDirect(GdkFont *font)
{
  sfont1 = font;
}


/* -------------------------------------------------------------
  RRScreenFontSetInit   -- եȤλʤ

   return : void
   fontname - եȥå̾
-------------------------------------------------------------- */
void       RRScreenFontSetInit(gchar *fontname)
{
  sfont1 = gdk_fontset_load(fontname);
}


/* -------------------------------------------------------------
  RRScreenFontInit   -- եȤλʤ

   return : void
   fontname - եȥå̾
-------------------------------------------------------------- */
void       RRScreenFontInit(gchar *fontname)
{
  sfont1 = gdk_font_load(fontname);
}


/* -------------------------------------------------------------
  RRScreenFontLocate -- եȤֻ

   return : void
   x, y - ɸλ
-------------------------------------------------------------- */
void       RRScreenFontLocate(gint x, gint y)
{
  font_x = x;
  font_y = y;
}


/* -------------------------------------------------------------
  RRScreenFontSize -- ɽʸνĲ

   return : void
   disp - ʸ
   *w, *h - 
-------------------------------------------------------------- */
void       RRScreenFontSize(gchar *disp, gint *w, gint *h)
{
  *w = gdk_string_width(sfont1, disp);
  *h = gdk_string_height(sfont1, disp);
}


/* -------------------------------------------------------------
  RRScreenFontPrint  -- ʸɽ

   return : void
   disp - ɸλ
-------------------------------------------------------------- */
void       RRScreenFontPrint(const gchar *disp)
{
  RRRectangle  area;
  gint  w, h;

  w = gdk_string_width(sfont1, disp);
  h = gdk_string_height(sfont1, disp);
  gdk_gc_set_clip_mask(win_gc[page], NULL);
  gdk_gc_set_clip_origin(win_gc[page], 0, 0);
  gdk_draw_string(pixmap[page], sfont1, win_gc[page],
		  font_x, font_y+h-1, disp);
  /* -- ѤäꥢεϿ */
  area.x = font_x;
  area.y = font_y;
  area.w = w;
  area.h = h;
  memo_add_bound(&area);
  /* -- ɽ֤ʤ */
  if ((font_x += w) > screen_w) {
    font_x = 0;
    if ((font_y += h) > screen_h) {
      font_y = 0;
    }
  }
}


/* -------------------------------------------------------------
  RRScreenFontPrintDirect  -- Pixmapʸɽ

   return : void
   disp - ɸλ
-------------------------------------------------------------- */
void       RRScreenFontPrintDirect(GdkPixmap *target, const gchar *disp)
{
  gint  w, h;

  w = gdk_string_width(sfont1, disp);
  h = gdk_string_height(sfont1, disp);
  gdk_draw_string(target, sfont1, win_gc[page],
		  font_x, font_y+h-1, disp);

  /* --- JAN.24.2000
     ᥤ󥹥꡼ GC 򤽤ΤޤѤƤ뤬
     ϡǤ롣target  screen Ʊ display 
     뤳Ȥݾڤ GC ̤Ǥ뤳ȤǧʤƤ
     ʤʤ
     */
}


/* -------------------------------------------------------------
  RRScreenPutPixmap  -- 襹꡼Pixmapɽ

   return : void
   picture - žɽ
   x, y - ɽ֥եå
-------------------------------------------------------------- */
void       RRScreenPutPixmap(GdkPixmap *picture,  gint x, gint y)
{
  RRRectangle  area;
  gint  w, h;

  gdk_window_get_size(picture, &w, &h);
  gdk_gc_set_clip_mask(win_gc[page], NULL);
  gdk_gc_set_clip_origin(win_gc[page], x, y);
  gdk_draw_pixmap(pixmap[page], win_gc[page], picture, 0, 0,
		  x, y, w, h);
  /* -- ѤäꥢεϿ */
  area.x = x;
  area.y = y;
  area.w = w;
  area.h = h;
  memo_add_bound(&area);
}


/* -------------------------------------------------------------
  RRScreenObjPut           -- Objectɽ

   return : void
   spr - žɽץ饤Ȥξ¤
-------------------------------------------------------------- */
void       RRScreenObjPut(RRSprite *spr)
{
  RRRectangle  area;
  gint  w, h, x, y, ox, oy;

  if (spr->sw == FALSE) return;

  x = spr->x - spr->offset_x;
  y = spr->y - spr->offset_y;
  w = spr->w;
  h = spr->h;
  /* -- ϰϥå */
  if ((((x+w) < 0) || (x > screen_w) || ((y+h) < 0) || (y > screen_h)) == FALSE) {
    ox = spr->ox;
    oy = spr->oy;
    /* -- Ϥ߽Фå */
    if (x < 0) {
      ox -= x;
      w += x;
      x = 0;
    }
    if (y < 0) {
      oy -= y;
      h += y;
      y = 0;
    }
    if ((x+w) >= screen_w) {
      w -= ((x+w) - screen_w);
    }
    if ((y+h) >= screen_h) {
      h -= ((y+h) - screen_h);
    }
    /* -- åץޥ */
    gdk_gc_set_clip_mask(win_gc[page], spr->objmask);
    if (spr->mask_offset == TRUE) {
      gdk_gc_set_clip_origin(win_gc[page], x-ox, y-oy);
    }
    else {
      gdk_gc_set_clip_origin(win_gc[page], spr->x, spr->y);
    }
    /* -- Obj  */
    gdk_draw_pixmap(pixmap[page], win_gc[page], spr->objmap, ox, oy,
		    x, y, w, h);
    /* -- ѤäꥢεϿ */
    area.x = x;
    area.y = y;
    area.w = w;
    area.h = h;
    memo_add_bound(&area);
  }
}


/* -------------------------------------------------------------
  RRScreenObjPutDirect      -- PixmapObjectɽ

   return : void
   target - ž
   spr - žɽץ饤Ȥξ¤
-------------------------------------------------------------- */
void       RRScreenObjPutDirect(GdkPixmap *target, RRSprite *spr)
{
  GdkGC  *dgc;
  gint  w, h, x, y, ox, oy;

  if (spr->sw == FALSE) return;

  x = spr->x - spr->offset_x;
  y = spr->y - spr->offset_y;
  w = spr->w;
  h = spr->h;
  /* -- ϰϥå */
  if ((((x+w) < 0) || (x > screen_w) || ((y+h) < 0) || (y > screen_h)) == FALSE) {
    ox = spr->ox;
    oy = spr->oy;
    /* -- Ϥ߽Фå */
    if (x < 0) {
      ox -= x;
      w += x;
      x = 0;
    }
    if (y < 0) {
      oy -= y;
      h += y;
      y = 0;
    }
    if ((x+w) > screen_w) {
      w -= ((x+w) - screen_w);
    }
    if ((y+h) > screen_h) {
      h -= ((y+h) - screen_h);
    }
    /* -- åץޥ */
    dgc = gdk_gc_new(target);
    gdk_gc_set_clip_mask(dgc, spr->objmask);
    if (spr->mask_offset == TRUE) {
      gdk_gc_set_clip_origin(dgc, x-ox, y-oy);
    }
    else {
      gdk_gc_set_clip_origin(dgc, spr->x, spr->y);
    }
    /* -- Obj  */
    gdk_draw_pixmap(target, dgc, spr->objmap, ox, oy,
		    x, y, w, h);
    gdk_gc_destroy(dgc);
  }
}



/* -------------------------------------------------------------
  RRScreenPoint            -- ɽ

   return : void
   x, y - Ǥĺɸ
-------------------------------------------------------------- */
void       RRScreenPoint(gint x, gint y)
{
  RRRectangle area;

  gdk_gc_set_clip_mask(win_gc[page], NULL);
  gdk_gc_set_clip_origin(win_gc[page], 0, 0);
  gdk_draw_point(pixmap[page], win_gc[page], x, y);
  /* -- ѤäꥢεϿ */
  area.x = x;
  area.y = y;
  area.w = area.h = 1;
  memo_add_bound(&area);
}

/* -------------------------------------------------------------
  RRScreenLine             -- 饤ɽ

   return : void
   x1, y1, x2, y2 - Ҥɸ
-------------------------------------------------------------- */
void       RRScreenLine(gint x1, gint y1, gint x2, gint y2)
{
  RRRectangle area;
  gint  t;

  gdk_gc_set_clip_mask(win_gc[page], NULL);
  gdk_gc_set_clip_origin(win_gc[page], 0, 0);
  gdk_draw_line(pixmap[page], win_gc[page], x1, y1, x2, y2);
  /* -- ѤäꥢεϿ */
  if (x1 > x2) {
    t = x1;
    x1 = x2;
    x2 = t;
  }
  if (y1 > y2) {
    t = y1;
    y1 = y2;
    y2 = t;
  }
  area.x = x1;
  area.y = y1;
  area.w = x2 - x1 + 1;
  area.h = y2 - y1 + 1;
  memo_add_bound(&area);
}

/* -------------------------------------------------------------
  RRScreenRectangle        -- ͳѤɽ

   return : void
   x, y, w, h - Ҥɸ
-------------------------------------------------------------- */
void       RRScreenRectangle(gint fill, gint x, gint y, gint w, gint h)
{
  RRRectangle area;

  if (x < 0) {
    w += x;
    x = 0;
  }
  if (y < 0) {
    h += y;
    y = 0;
  }
  if ((w > 0) && (h > 0)) {
    gdk_gc_set_clip_mask(win_gc[page], NULL);
    gdk_gc_set_clip_origin(win_gc[page], 0, 0);
    gdk_draw_rectangle(pixmap[page], win_gc[page], fill, x, y, w, h);
    
    /* -- ѤäꥢεϿ */
    area.x = x;
    area.y = y;
    area.w = w;
    area.h = h;
    memo_add_bound(&area);
  }
}




/* -------------------------------------------------------------
  RRGetParts         -- åȾλ̾ҥåȤ֤

   return : void
   mainwin - õ widget
   name - õ widget name
-------------------------------------------------------------- */
GtkWidget *RRGetParts(GtkWidget *mainwin, gchar *name)
{
  GtkWidget *parts = NULL;
  GList *wlist, *tmp;
  gint  n, i;
  gint max;

  wlist = gtk_container_children(GTK_CONTAINER(mainwin));
  max = g_list_length(wlist);
  n = -1;
  for(i=0; i<max; i++) {
    tmp = g_list_nth(wlist, i);
    parts = GTK_WIDGET(tmp->data);
    if (strcmp((char*)gtk_widget_get_name(parts), name) == 0) {
      /* -- ߡĤ */
      n = i;
      break;
    }
  }
  if (n == -1) {
    parts = NULL;
  }

  return(parts);
}


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */
/* ----------------------------------------------------
  memo_add_bound        --- Ѥä꡼Ͽ
----------------------------------------------------- */
void  memo_add_bound(RRRectangle *addarea)
{
  GList  *pt;
  RRRectangle *newarea;
  gint  i, n, pos[8];
  gboolean  flag;

  n = g_list_length(drawmemo);
  pt = drawmemo;
  flag = TRUE;
  for(i=0; i<n; i++) {
    if (check_over_area(pt->data, addarea) == TRUE) {
      /* --- ۤȹƤäʥ꡼ˤ */
      newarea = pt->data;
      pos[0] = newarea->x;
      pos[1] = newarea->y;
      pos[2] = newarea->x + newarea->w - 1;
      pos[3] = newarea->y + newarea->h - 1;
      pos[4] = addarea->x;
      pos[5] = addarea->y;
      pos[6] = addarea->x + addarea->w - 1;
      pos[7] = addarea->y + addarea->h - 1;
      if (pos[0] > pos[4]) pos[0] = pos[4];
      if (pos[1] > pos[5]) pos[1] = pos[5];
      if (pos[2] < pos[6]) pos[2] = pos[6];
      if (pos[3] < pos[7]) pos[3] = pos[7];
      newarea->x = pos[0];
      newarea->y = pos[1];
      newarea->w = pos[2] - pos[0] + 1;
      newarea->h = pos[3] - pos[1] + 1;
      flag = FALSE;
      break;
    }
    pt = pt->next;
  }
  if (flag == TRUE) {
   /* --- ꡼Ȥɲ */
   newarea = (RRRectangle *)g_mem_chunk_alloc(memo_chunk);
   newarea->x = addarea->x;
   newarea->y = addarea->y;
   newarea->w = addarea->w;
   newarea->h = addarea->h;
   drawmemo = g_list_append(drawmemo, newarea);
 }
}

/* -------------------------------------------------------------
  check_over_area       -- ΰ褬ŤʤäƤ뤫ݤ
-------------------------------------------------------------- */
gboolean  check_over_area(RRRectangle *a, RRRectangle *b)
{
  gboolean r = FALSE;
  gint pos[8];

  pos[0] = a->x;
  pos[1] = a->y;
  pos[2] = a->x + a->w;
  pos[3] = a->y + a->h;
  pos[4] = b->x;
  pos[5] = b->y;
  pos[6] = b->x + b->w;
  pos[7] = b->y + b->h;

  if (pos[0] < pos[4]) pos[0] = pos[4];
  if (pos[0] > pos[6]) pos[0] = pos[6];
  if (pos[2] < pos[4]) pos[2] = pos[4];
  if (pos[2] > pos[6]) pos[2] = pos[6];
  if (pos[1] < pos[5]) pos[1] = pos[5];
  if (pos[1] > pos[7]) pos[1] = pos[7];
  if (pos[3] < pos[5]) pos[3] = pos[5];
  if (pos[3] > pos[7]) pos[3] = pos[7];
  if ((pos[0] == pos[2]) || (pos[1] == pos[3])) {
    r = FALSE;
  }
  else {
    r = TRUE;
  }

  return(r);
}

/* ----------------------------------------------------
  free_drawmemo    --- ˴
----------------------------------------------------- */
void  free_drawmemo(GList *memo)
{
  GList  *pt;
  gint  i, n;

  n = g_list_length(memo);
  pt = memo;
  for(i=0; i<n; i++) {
    g_mem_chunk_free(memo_chunk, pt->data);
    pt = pt->next;
  }
  g_list_free(memo);
  memo = NULL;
}
